#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "apood.sis";
const char *OUT = "apood.val";
const char *HINT = "apood.xxx";

void ERR(const char *s) {
    printf("400\nError: %s\n", s);
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r'))
        s[i--] = 0;
    return s;
}

int n, nn;
char s[200];
int a1, a2, a3, a4, a5;
int aa1, aa2, aa3, aa4, aa5;
int u;

int main() {
    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    if (!fgets(s, sizeof(s), hint))
        ERR("Viga vihjefaili lugemisel");
    if (strcmp(trim(s), "EI OLE") == 0) {
        n = 0;
    } else {
        sscanf(s, "%d", &n);
    }

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili avamisel");
    if (!fgets(s, sizeof(s), out))
        OK(0, "Enneaegne faili lpp");
    if (n == 0) {
        if (strcmp(trim(s), "EI OLE") != 0)
            OK(0, "Vale vastus");
    } else {
        if (strcmp(trim(s), "EI OLE") == 0)
            OK(0, "Vale vastus");
        if (sscanf(s, "%d%n", &nn, &u) != 1)
            OK(0, "Viga tisarvu lugemisel");
        if (u < strlen(s))
            OK(0, "Liigsed smbolid rea lpus");
        if (nn != n)
            OK(0, "Vale vljundridade arv");
        for (int i = 0; i < n; ++i) {
            if (fscanf(hint, "%d %d %d %d %d", &a1, &a2, &a3, &a4, &a5) != 5)
                ERR("Viga vihjefaili lugemisel");
            if (!fgets(s, sizeof(s), out))
                OK(0, "Enneaegne faili lpp");
            if (sscanf(s, "%d %d %d %d %d %n", &aa1, &aa2, &aa3, &aa4, &aa5, &u) != 5)
                OK(0, "Viga tisarvude lugemisel");
            if (u < strlen(s))
                OK(0, "Liigsed smbolid rea lpus");
            if (aa1 != a1 || aa2 != a2 || aa3 != a3 || aa4 != a4 || aa5 != a5)
                OK(0, "Vale vastus");
        }
    }
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read faili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");
    OK(100, "OK");
}
