/* 2005-12-17 programmeerimisvistlus                                      */
/* lesanne: ARVUTIPOOD, raskem variant                                    */
/* Autor: Tanel Talvik, Indrek Jentson                                     */
/* Testitud: GCC 3.2.3 / MinGW                                             */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define IN "epood.sis"
#define OUT "epood.val"
#define ARVUTEID 10000
#define MUUTUJAID 5

char muutujad[]="HPMKV";

/** Struktuur TINGIMUS
 * muutuja - muutuja hulgast {H,P,M,K,V}
 * operaator - operaator hulgast {=<,>=}
 * vaartus - tisarv vahemikus 0-10000
 */

typedef struct {
  char muutuja;
  char operaator[3];
  int vaartus;
}TINGIMUS;

/** Struktuur ARVUTI
 * m[0] - hind
 * m[1] - protsessor
 * m[2] - mlu
 * m[3] - kvaketas
 * m[4] - videomlu
 */
typedef struct {
  int muutuja[MUUTUJAID];
}ARVUTI;

int arvuteid=0;
ARVUTI arvutid[ARVUTEID];
int tingimusi=0;
TINGIMUS tingimused[10];
int tulemusi=0;
int tulemused[ARVUTEID];
char X;
char Y[3];
int Z;
char JA[3];

/* Funktsioon tingimuse kontrollimiseks */
int kontrolli_tingimust(TINGIMUS* tingimus, ARVUTI* arvuti) {
  int i;
  int muutuja=-1;
  for(i=0; i<MUUTUJAID; i++) {
    if(tingimus->muutuja==muutujad[i]) {
      muutuja=i;
      break;
    }
  }
  if(muutuja!=-1){
    if(strcmp(tingimus->operaator,"=<")==0) {
      if(arvuti->muutuja[i]<=tingimus->vaartus)return 1;
      else return 0;
    }
    if(strcmp(tingimus->operaator,">=")==0) {
      if(arvuti->muutuja[i]>=tingimus->vaartus)return 1;
      else return 0;
    }
    printf("Vale operaator %s sisendfailis.\n", tingimus->operaator);
  }
  else
    printf("Vale muutujanimi %c sisendfailis.\n", tingimus->muutuja);
  return 0;
}

/* Protseduur vljundi kirjutamiseks */
void write_output(){
  FILE *out;
  int i, j;
  if((out=fopen(OUT, "wt"))==NULL){
     printf("Ei suuda avada kirjutamisks!\n");
  }
  if(tulemusi>0){
    fprintf(out,"%d\n", tulemusi);
    for(i=0; i<tulemusi; i++){
      for(j=0; j<MUUTUJAID; j++)
        if(j!=MUUTUJAID-1)fprintf(out,"%d ",arvutid[tulemused[i]].muutuja[j]);
        else fprintf(out,"%d\n",arvutid[tulemused[i]].muutuja[j]);
    }
  }
  else fprintf(out,"%s\n","EI OLE");
  fclose(out);
}

/* Protseduur tulemuste leidmiseks */
void find_results(){
  int i,j;
  int tingimused_taidetud;
  for(i=0;i<arvuteid;i++) {
    tingimused_taidetud=1;
    for(j=0; j<tingimusi; j++) {
      if(!kontrolli_tingimust(&tingimused[j], &arvutid[i])) {
        tingimused_taidetud=0;
        break;
      }
    }
    if(tingimused_taidetud) {
      tulemused[tulemusi++]=i;
    }
  }
}

/* Funktsioon sisendi lugemiseks ja parsimiseks */
int read_input() {
  FILE *in;
  int i, j, m;
  if((in=fopen(IN, "rt"))==NULL){
     printf("Ei suuda avada lugemiseks!\n");
     return 0;
  }
  fscanf(in, "%d ", &arvuteid);
  for(i=0;i<arvuteid;i++){
    /* Pame sisse lugeda arvutite kirjeldused */
    for(j=0; j<MUUTUJAID; j++) {
      if(fscanf(in, "%d ", &m)==1) {
        arvutid[i].muutuja[j]=m;
      }
      else {
        printf("Leitud poolik kirje failist.\n");
        return 0;
      }
    }
  }
  /* Parsime tingimused */
  while(1){
    if(fscanf(in, "%c %2s %d ", &X, &Y, &Z)==3) {
      tingimused[tingimusi].muutuja=X;
      strcpy(tingimused[tingimusi].operaator,Y);
      tingimused[tingimusi].vaartus=Z;
      tingimusi++;
      if(fscanf(in, "%2s ", JA)!=1)
          break;
      if(strcmp(JA, "JA")!=0)
          break;
    }
    else printf("Tingimusi ei leitud.\n");
  }
  fclose(in);
  return 1;
}

/* Main funktsioon */
int main(){
  if(read_input()>0){
    find_results();
    write_output();
  }
  return EXIT_SUCCESS;
}
