/* 2005-12-17 programmeerimisvistlus                                      */
/* lesanne: ARVUTIPOOD, raskem variant                                    */
/* Autor: Ahto Truu                                                        */
/* Testitud: GCC 3.2.3 / MinGW                                             */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SISF "epood.sis"                               /* sisendfaili nimi */
#define VALF "epood.val"                              /* vljundfaili nimi */
#define MAXN 10000                             /* maksimaalne arvutite arv */

typedef struct {                                      /* he arvuti andmed */
  int h, p, m, k, v;
  int ok;                  /* kas rahuldab kiki seni vaadeldud tingimusi? */
} ARVUTI;

FILE *f;                            /* failimuutuja sisendi/vljundi jaoks */

int n;                                             /* arvutite tegelik arv */
ARVUTI a[MAXN];                                         /* arvutite andmed */

char t[4];                            /* tingimuse parameeter ja operaator */
int v;                                           /* parameetri piirvrtus */

int m;                               /* tingimust rahuldavate arvutite arv */

int main() {
    int i;

    /* loeme arvutite andmed */
    f = fopen(SISF, "rt");
    fscanf(f, "%d ", &n);                                  /* arvutite arv */
    for (i = 0; i < n; ++i) {                      /* arvutite parameetrid */
        fscanf(f, "%d %d %d %d %d ",
            &a[i].h, &a[i].p, &a[i].m, &a[i].k, &a[i].v);
        a[i].ok = 1;
    }

    /* loeme ja ttleme jrjest kik tingimused */
    while (1) {
        fscanf(f, "%c%c%c%c %d ",                              /* tingimus */
            &t[0], &t[1], &t[2], &t[3], &v);
        /* kontrollime kiki arvuteid */
        for (i = 0; i < n; ++i) {
            /* kontrollime kshaaval vimalikke tingimusi */
            if (strncmp(t, "H =<", 4) == 0)
                if (a[i].h > v)
                    a[i].ok = 0;
            if (strncmp(t, "H >=", 4) == 0)
                if (a[i].h < v)
                    a[i].ok = 0;
            if (strncmp(t, "P =<", 4) == 0)
                if (a[i].p > v)
                    a[i].ok = 0;
            if (strncmp(t, "P >=", 4) == 0)
                if (a[i].p < v)
                    a[i].ok = 0;
            if (strncmp(t, "M =<", 4) == 0)
                if (a[i].m > v)
                    a[i].ok = 0;
            if (strncmp(t, "M >=", 4) == 0)
                if (a[i].m < v)
                    a[i].ok = 0;
            if (strncmp(t, "K =<", 4) == 0)
                if (a[i].k > v)
                    a[i].ok = 0;
            if (strncmp(t, "K >=", 4) == 0)
                if (a[i].k < v)
                    a[i].ok = 0;
            if (strncmp(t, "V =<", 4) == 0)
                if (a[i].v > v)
                    a[i].ok = 0;
            if (strncmp(t, "V >=", 4) == 0)
                if (a[i].v < v)
                    a[i].ok = 0;
        }
        if (fscanf(f, "%c%c ", &t[0], &t[1]) != 2)        /* kui JA ei ole */
            break;                      /* siis on tingimused lbi ja lpp */
    }
    fclose(f);

    /* loeme kokku vastuste arvu */
    m = 0;
    for (i = 0; i < n; ++i)
        if (a[i].ok)
            ++m;

    /* vljastame */
    f = fopen(VALF, "wt");
    if (m == 0)
        fprintf(f, "%s\n", "EI OLE");
    else {
        fprintf(f, "%d\n", m);
        for (i = 0; i < n; ++i)
            if (a[i].ok)
                fprintf(f, "%d %d %d %d %d\n",
                    a[i].h, a[i].p, a[i].m, a[i].k, a[i].v);
    }
    fclose(f);

    return 0;
}
