#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "lukud.sis";
const char *OUT = "lukud.val";
const char *HINT = "lukud.xxx";

void ERR(const char *s) {
    printf("400\nError: %s\n", s);
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r'))
        s[i--] = 0;
    return s;
}

int var(const char *s) {
    if (strcmp(s, "JAH") == 0)
        return 1;
    if (strcmp(s, "EI") == 0)
        return 2;
    if (strcmp(s, "VIGA") == 0)
        return 3;
    return 0;
}

char s[200];
int v, vv;
int n, nn, u;

int main() {
    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    if (!fgets(s, sizeof(s), hint))
        ERR("Viga vihjefaili lugemisel");
    v = var(trim(s));
    if (v == 1 || v == 3)
        if (fscanf(hint, "%d ", &n) != 1)
            ERR("Viga vihjefaili lugemisel");
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili avamisel");
    if (!fgets(s, sizeof(s), out))
        OK(0, "Enneaegne faili lpp");
    vv = var(trim(s));
    if (vv == 0)
        OK(0, "Tundmatu vastusevariant");
    if (vv == 1 || vv == 3) {
        if (!fgets(s, sizeof(s), out))
            OK(0, "Enneaegne faili lpp");
        if (sscanf(s, "%d %n", &nn, &u) != 1)
            OK(0, "Viga tisarvu lugemisel");
        if (u < strlen(s))
            OK(0, "Liigsed smbolid rea lpus");
    }
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read faili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");

    if (v != vv || n != nn)
        OK(0, "Vale vastus");
    OK(100, "OK");
}
