#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "sulud.sis";
const char *OUT = "sulud.val";
const int MAXN = 20;

void ERR(const char *s) {
    printf("400\nError: %s\n", s);
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r'))
        s[i--] = 0;
    return s;
}

void chck(int m, int n, char *s) {
    if (strlen(s) != n)
        OK(0, "Ebakorrektne avaldise pikkus");
    char t[MAXN];
    int k = 0;
    for (int i = 0; s[i]; ++i) {
        if (s[i] == '(' && m > 0) {
            t[k++] = ')';
            continue;
        }
        if (s[i] == '[' && m > 1) {
            t[k++] = ']';
            continue;
        }
        if (s[i] == '{' && m > 2) {
            t[k++] = '}';
            continue;
        }
        if (s[i] == ')' || s[i] == ']' || s[i] == '}') {
            if (k > 0 && t[--k] == s[i])
                continue;
            OK(0, "Ebakorrektne avaldis");
        }
        OK(0, "Lubamatu smbol");
    }
}

int comp(const void *p1, const void *p2) {
    return strcmp(*(char **)p1, *(char **)p2);
}

int a[MAXN+1]; // lihtavaldiste arvud pikkuste kaupa
int b[MAXN+1]; // kigi avaldiste arvud pikkuste kaupa

int m, n;
char s[MAXN + 1 + 1];
char **x;
int k;

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR("Viga sisendfaili avamisel");
    if (fscanf(in, "%d %d", &m, &n) != 2)
        ERR("Viga sisendfaili lugemisel");
    if (fclose(in))
        ERR("Viga sisendfaili sulgemisel");

    // arvutame avaldiste arvud
    a[0] = b[0] = 1;
    for (int i = 2; i <= n; i += 2) {
        a[i] = m * b[i - 2];
        b[i] = 0;
        for (int k = 0; k < i; k += 2)
            b[i] += a[i - k] * b[k];
    }

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili avamisel");
    x = (char **) malloc(b[n] * sizeof(*x));
    k = 0;
    while (fgets(s, sizeof(s), out)) {
        chck(m, n, trim(s));
        if (k < b[n])
            x[k] = strdup(s);
        ++k;
    }
    if (k < b[n])
        OK(0, "Enneaegne faili lpp");
    if (k > b[n])
        OK(0, "Liigsed read faili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");

    qsort(x, m, sizeof(*x), comp);
    for (int i = 1; i < m; ++i)
        if (strcmp(x[i - 1], x[i]) == 0)
            OK(0, "Korduv avaldis");
    OK(100, "OK");
}
